# Generated by Django 3.1.3 on 2020-12-01 07:55

from django.db import migrations

from web.models.constants import GLOBAL_STUDY_ID
from web.models.study import FOLLOW_UP_INCREMENT_IN_YEARS
from ..migration_functions import is_sqlite_db

patient_prefix = 'P'
patient_delta_time = str(1)
patient_delta_units = FOLLOW_UP_INCREMENT_IN_YEARS
patient_type_id = 1

control_prefix = 'L'
control_delta_time = str(4)
control_delta_units = FOLLOW_UP_INCREMENT_IN_YEARS
control_type_id = 2

auto_create_follow_up = str(True)


def fetch_subject_type_data(apps, schema_editor) -> None:
    # noinspection PyPep8Naming
    Study = apps.get_model("web", "Study")
    study = Study.objects.get(pk=GLOBAL_STUDY_ID)
    global patient_delta_time, patient_delta_units, control_delta_time, control_delta_units, auto_create_follow_up

    patient_delta_time = str(study.default_delta_time_for_patient_follow_up)
    patient_delta_units = study.default_delta_time_for_follow_up_units

    control_delta_time = str(study.default_delta_time_for_control_follow_up)
    control_delta_units = study.default_delta_time_for_follow_up_units

    auto_create_follow_up = str(study.auto_create_follow_up)

    if is_sqlite_db():
        if auto_create_follow_up.lower() == "false":
            auto_create_follow_up = "0"
        else:
            auto_create_follow_up = "1"
    pass


def fetch_subject_type_id_data(apps, schema_editor) -> None:
    # noinspection PyPep8Naming
    SubjectType = apps.get_model("web", "SubjectType")
    global patient_type_id, control_type_id
    patient_type_id = SubjectType.objects.get(name='PATIENT').id
    control_type_id = SubjectType.objects.get(name='CONTROL').id
    pass


class Migration(migrations.Migration):
    dependencies = [
        ('web', '0193_subjecttype'),
    ]

    operations = [
        migrations.RunPython(fetch_subject_type_data),
        migrations.RunSQL("insert into web_subjecttype " +
                          "(name, screening_number_prefix, follow_up_delta_time, follow_up_delta_units, "
                          "auto_create_follow_up, study_id) " +
                          "values(" +
                          "'PATIENT','" +
                          patient_prefix + "', " +
                          patient_delta_time + ",'" +
                          patient_delta_units + "'," +
                          auto_create_follow_up + "," +
                          str(GLOBAL_STUDY_ID) + ")"),
        migrations.RunSQL("insert into web_subjecttype " +
                          "(name, screening_number_prefix, follow_up_delta_time, follow_up_delta_units, "
                          "auto_create_follow_up, study_id) " +
                          "values(" +
                          "'CONTROL','" +
                          control_prefix + "', " +
                          control_delta_time + ",'" +
                          control_delta_units + "'," +
                          auto_create_follow_up + "," +
                          str(GLOBAL_STUDY_ID) + ")"),
        migrations.RunPython(fetch_subject_type_id_data),
        migrations.RunSQL("update web_studysubject " +
                          " set new_type_id = " + str(patient_type_id) + " where type = 'P'"),
        migrations.RunSQL("update web_studysubject " +
                          " set new_type_id = " + str(control_type_id) + " where type = 'C'"),
    ]
