# coding=utf-8
import logging

from django.db import models
from django.db.models import Field

from web.models import Language, SubjectType
from web.models.etl.etl import EtlData

logger = logging.getLogger(__name__)


class SubjectImportData(EtlData):
    location = models.ForeignKey("web.Location",
                                 verbose_name='Default location',
                                 blank=True,
                                 null=True,
                                 on_delete=models.SET_NULL
                                 )
    country = models.ForeignKey("web.Country",
                                verbose_name='Default country',
                                blank=True,
                                null=True,
                                on_delete=models.SET_NULL
                                )


def field_can_be_imported(field: Field):
    return field.get_internal_type() == "CharField" or \
           field.get_internal_type() == "DateField" or \
           field.get_internal_type() == "TextField" or \
           field.get_internal_type() == "ForeignKey" and field.related_model in (Language, SubjectType)
